/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/hardware/dynamixel-genom3/work/templates/ros/client/ros/dynamixel/srv/set_profile.srv
 *
 */


#ifndef DYNAMIXEL_MESSAGE_SET_PROFILEREQUEST_H
#define DYNAMIXEL_MESSAGE_SET_PROFILEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <dynamixel/dynamixel_profile_s.h>

namespace dynamixel
{
template <class ContainerAllocator>
struct set_profileRequest_
{
  typedef set_profileRequest_<ContainerAllocator> Type;

  set_profileRequest_()
    : id(0)
    , desired()  {
    }
  set_profileRequest_(const ContainerAllocator& _alloc)
    : id(0)
    , desired(_alloc)  {
    }



   typedef uint16_t _id_type;
  _id_type id;

   typedef  ::dynamixel::dynamixel_profile_s_<ContainerAllocator>  _desired_type;
  _desired_type desired;




  typedef boost::shared_ptr< ::dynamixel::set_profileRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dynamixel::set_profileRequest_<ContainerAllocator> const> ConstPtr;

}; // struct set_profileRequest_

typedef ::dynamixel::set_profileRequest_<std::allocator<void> > set_profileRequest;

typedef boost::shared_ptr< ::dynamixel::set_profileRequest > set_profileRequestPtr;
typedef boost::shared_ptr< ::dynamixel::set_profileRequest const> set_profileRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dynamixel::set_profileRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dynamixel::set_profileRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dynamixel

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'dynamixel': ['dynamixel/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dynamixel::set_profileRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dynamixel::set_profileRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamixel::set_profileRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamixel::set_profileRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamixel::set_profileRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamixel::set_profileRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dynamixel::set_profileRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cd8a4141184092d6a8d9120249b63b68";
  }

  static const char* value(const ::dynamixel::set_profileRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xcd8a4141184092d6ULL;
  static const uint64_t static_value2 = 0xa8d9120249b63b68ULL;
};

template<class ContainerAllocator>
struct DataType< ::dynamixel::set_profileRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dynamixel/set_profileRequest";
  }

  static const char* value(const ::dynamixel::set_profileRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dynamixel::set_profileRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
uint16 id\n\
dynamixel_profile_s desired\n\
\n\
================================================================================\n\
MSG: dynamixel/dynamixel_profile_s\n\
# IDL struct ::dynamixel::profile_s\n\
float64 velocity\n\
float64 acceleration\n\
";
  }

  static const char* value(const ::dynamixel::set_profileRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dynamixel::set_profileRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.id);
      stream.next(m.desired);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct set_profileRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dynamixel::set_profileRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dynamixel::set_profileRequest_<ContainerAllocator>& v)
  {
    s << indent << "id: ";
    Printer<uint16_t>::stream(s, indent + "  ", v.id);
    s << indent << "desired: ";
    s << std::endl;
    Printer< ::dynamixel::dynamixel_profile_s_<ContainerAllocator> >::stream(s, indent + "  ", v.desired);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DYNAMIXEL_MESSAGE_SET_PROFILEREQUEST_H
